<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Capsule\Manager;

use App\Http\Services\PenerimaanbarangService;
use App\Http\Services\PopenerimaanService;
use App\Http\Services\ItempenerimaanbarangService;
use App\Http\Services\ItempopenerimaanService;
use App\Http\Services\PenggunaanbarangService;
use App\Http\Services\ItempenggunaanbarangService;


class AdjustmentModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "pelni_scm_adj_trx_v";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "adj";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "SOURCE", "TRANSACTION_ID", "TRANSACTION_NUM", "ITEM_ID", "QTY", "UOM_CODE", "PO", "PO_ID", "ORGANIZATION_ID", "FROM_SUBINVENTORY", "LOT_NUMBER", "CREATION_DATE", "LAST_UPDATE_DATE", "FLAG_UPDATE", "TRANSACTION_DATE"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "adj.id",
    ];

    public function syncFromOracleHO($syncTable, $fromCMS = false)
    {
        echo "start sync data adj from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Adjustment", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows, $fromCMS);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Adjustment", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }

    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT ADJ.* FROM pelni_scm_adj_trx_v ADJ
                    WHERE ADJ.LAST_UPDATE_DATE >= TO_DATE('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS') 
                    AND TRANSACTION_ID IS NOT NULL AND TRANSACTION_NUM IS NOT NULL
                    ORDER BY ADJ.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->SOURCE = $oracle->SOURCE;
        $this->TRANSACTION_ID = $oracle->TRANSACTION_ID;
        $this->TRANSACTION_NUM = $oracle->TRANSACTION_NUM;
        $this->ITEM_ID = $oracle->ITEM_ID;
        $this->QTY = $oracle->QTY;
        $this->UOM_CODE = $oracle->UOM_CODE;
        $this->PO = $oracle->PO;
        $this->PO_ID = $oracle->PO_ID;        
        $this->ORGANIZATION_ID = $oracle->ORGANIZATION_ID;
        $this->FROM_SUBINVENTORY = $oracle->FROM_SUBINVENTORY;
        $this->LOT_NUMBER = $oracle->LOT_NUMBER;
        $this->CREATION_DATE = $oracle->CREATION_DATE;
        $this->LAST_UPDATE_DATE = $oracle->LAST_UPDATE_DATE;
        $this->TRANSACTION_DATE = $oracle->TRANSACTION_DATE;
    }

    public function storingDataFromOracle($oracle, $fromCMS = false)
    {
        $modelExist = new self();
        $modelExist = $modelExist->getQuery()->where("adj.TRANSACTION_ID", "=", $oracle->TRANSACTION_ID)
            ->where("adj.ITEM_ID", "=", $oracle->ITEM_ID)            
            ->first();
        
        if ($modelExist) {
            try {
                $model = self::find($modelExist->id);
                $model->mapperOracle($oracle);
                $model->update();
                (new LogsyncoracleModel)->setLogSync("Adjustment : ".$oracle->TRANSACTION_ID. " - ".$oracle->ITEM_ID." - ".$oracle->QTY, Carbon::now()->toDateTimeString(), "", "updated");
                
            
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Adjustment : ".$oracle->TRANSACTION_ID. " - ".$oracle->ITEM_ID." - ".$oracle->QTY, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        } else {
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->FLAG_UPDATE = 1;
                $model->save();
                (new LogsyncoracleModel)->setLogSync("Adjustment : ".$oracle->TRANSACTION_ID. " - ".$oracle->ITEM_ID." - ".$oracle->QTY , Carbon::now()->toDateTimeString(), "", "inserted");

                echo $model->SOURCE." ". $model->QTY ." \n";
                if($model->SOURCE == 'RCV_RETURN' ||  $model->SOURCE == 'RCV_CORRECTION' ){
                    self::calculateHO($model);
                }
                elseif ($model->SOURCE == 'MISC_ISSUE_ADJ' ||  $model->SOURCE == 'MISC_RCV_ADJ') {
                    self::adjustStockHO($model);
                }

            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Adjustment : ".$oracle->TRANSACTION_ID. " - ".$oracle->ITEM_ID." - ".$oracle->QTY , Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        }
        
    }

    public static function storeFromHO($data, $fromCMS = false)
    {
        $model = (new self())->getQuery()->where("adj.TRANSACTION_ID", "=", $data->TRANSACTION_ID)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->SOURCE = $data->SOURCE;
            $model->TRANSACTION_ID = $data->TRANSACTION_ID;
            $model->TRANSACTION_NUM = $data->TRANSACTION_NUM;
            $model->ITEM_ID = $data->ITEM_ID;
            $model->QTY = $data->QTY;
            $model->UOM_CODE = $data->UOM_CODE;
            $model->PO = $data->PO;
            $model->PO_ID = $data->PO_ID;        
            $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
            $model->FROM_SUBINVENTORY = $data->FROM_SUBINVENTORY;
            $model->LOT_NUMBER = $data->LOT_NUMBER;
            $model->CREATION_DATE = $data->CREATION_DATE;
            $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE;
            $model->TRANSACTION_DATE = $data->TRANSACTION_DATE;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Adjustment : ".$data->TRANSACTION_ID. " - ".$data->LOT_NUMBER." - ".$data->QTY , Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            if($fromCMS) { DB::beginTransaction(); } else { Manager::beginTransaction(); }
            try {                   
                if($data->SOURCE == 'RCV_RETURN' ||  $data->SOURCE == 'RCV_CORRECTION' ) {
                    self::calculateKapal($data);
                    (new LogsynckapalModel)->setLogSync("Adjustment : calculateKapal " . $data->SOURCE . " - " .$data->TRANSACTION_ID. " - ".$data->LOT_NUMBER." - ".$data->QTY , Carbon::now()->toDateTimeString(), "", "updated");
                }
                elseif ($data->SOURCE == 'MISC_ISSUE_ADJ' ||  $data->SOURCE == 'MISC_RCV_ADJ') {
                    self::adjustStockKapal($data);
                    (new LogsynckapalModel)->setLogSync("Adjustment : adjustStockKapal " . $data->SOURCE . " - " . $data->TRANSACTION_ID. " - ".$data->LOT_NUMBER." - ".$data->QTY , Carbon::now()->toDateTimeString(), "", "updated");
                }
                $FLAG_UPDATE = 1;
                if($fromCMS) { DB::commit(); } else { Manager::commit(); }
            } catch (\Exception $e) {
                if($fromCMS) { DB::rollBack(); } else { Manager::rollBack(); }
                $FLAG_UPDATE = 0;
            }

            $model = new self();            
            $model->SOURCE = $data->SOURCE;
            $model->TRANSACTION_ID = $data->TRANSACTION_ID;
            $model->TRANSACTION_NUM = $data->TRANSACTION_NUM;
            $model->ITEM_ID = $data->ITEM_ID;
            $model->QTY = $data->QTY;
            $model->UOM_CODE = $data->UOM_CODE;
            $model->PO = $data->PO;
            $model->PO_ID = $data->PO_ID;        
            $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
            $model->FROM_SUBINVENTORY = $data->FROM_SUBINVENTORY;
            $model->LOT_NUMBER = $data->LOT_NUMBER;
            $model->CREATION_DATE = $data->CREATION_DATE;
            $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE; 
            $model->FLAG_UPDATE = $FLAG_UPDATE;
            $model->TRANSACTION_DATE = $data->TRANSACTION_DATE;
            $model->save();
            (new LogsynckapalModel)->setLogSync("Adjustment : ".$data->TRANSACTION_ID. " - ".$data->LOT_NUMBER." - ".$data->QTY , Carbon::now()->toDateTimeString(), "", "inserted");                        
        }
       
    }

    public static function getAdjustment($fromCMS = false)
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_adjustment";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 20)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Adjustment", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] ."&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\AdjustmentModel::storeFromHO($item, $fromCMS);
                            $lastUpdate = $item->LAST_UPDATE_DATE;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }

                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Adjustment", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Adjustment", Carbon::now()->toDateTimeString(), "", "success");
    }

    public static function calculateHO($model){
    }
    public static function calculateKapal($model) {  

        // VARIABLE UTK DI LEMPAR KE SERVICE
        $qtyAdjusment = $model->QTY; 
        $status = 0; // 0 = open. 1 = close; 

        $itemPoService = new ItempopenerimaanService();
        $input = [
                    "itemID"    => [ $model->ITEM_ID => $model->ITEM_ID ],
                    "quantity"  => [ $model->ITEM_ID => $qtyAdjusment ],
                    "poNumber"  => $model->PO
                ];
        $itemPoService->updateQtyRemaining($input);

        $poService = new PopenerimaanService();
        $poService->updateStatusPO($status, $input);

        $pbService = new PenerimaanbarangService();
        $pbService->updateQty($model->TRANSACTION_NUM, $model->QTY);

        $itemPbService = new ItempenerimaanbarangService();
        $itemPbService->updateQty($model->TRANSACTION_NUM, $model->ITEM_ID, $model->QTY);        

        // STOCK HISTORY $stockService = new StokkapalService(); $stockService->saveAdjusmentToStockHistory($model);
    }

    public static function adjustStockHO($model){
    }

    public static function adjustStockKapal($model){
        $miService = new PenggunaanbarangService();
        $miService->updateQty($model->TRANSACTION_NUM, $model->QTY);

        $itemMiService = new ItempenggunaanbarangService();
        $itemMiService->updateQty($model->TRANSACTION_NUM, $model->ITEM_ID, $model->QTY);    

        // STOCK HISTORY $stockService = new StokkapalService(); $stockService->saveAdjusmentToStockHistory($model);
    }
}